
////////////////////////////////////////////////////////////////
/** <<Google Chart API>> @ google chart style - define*/
// do not show chart tabel at initial point
function drawChartLeft(cityname,chartTableName) {
	// decide to show chart table or not
	// only display the table in 'lulc' mode
	if (chartTableName != null) {
		// control the chart table
		var data = google.visualization.arrayToDataTable(chartTableName);
		var options = {
			title: cityname,
			backgroundColor: 'transparent',
			legend:{
				position: 'top' // 'right'
			}, 
			hAxis: {
				title: 'Total Area (ha\'000)',
				minValue: 0
			},
			vAxis: {
				//title: 'LULC'
			},
			bars: 'horizontal',
			axes: {
				y: {
					0: {side: 'left'}
				}
			}
		};

		// two types of call function
		//var chart = new google.charts.Bar(document.getElementById('chart_div_left'));
		var chart = new google.visualization.BarChart(document.getElementById('chart_div_left'));
		chart.draw(data, options);
	}
}
function drawChartRight(cityname,chartTableName) {
	// decide to show chart table or not
	// only display the table in 'lulc' mode
	if (chartTableName != null) {
		
		// control the chart table
		var data = google.visualization.arrayToDataTable(chartTableName);
		var options = {
			title: cityname,
			backgroundColor: 'transparent',
			legend:{
				position: 'top' // 'right'
			}, 
			hAxis: {
				title: 'Total Area (ha\'000)',
				minValue: 0
			},
			vAxis: {
				//title: 'LULC'
			},
			bars: 'horizontal',
			axes: {
				y: {
					0: {side: 'left'}
				}
			}
		};

		// two types of call function
		//var chart = new google.charts.Bar(document.getElementById('chart_div_left'));
		var chart = new google.visualization.BarChart(document.getElementById('chart_div_right'));
		chart.draw(data, options);
	}
}


////////////////////////////////////////////////////////////////
/** <<Google Traffic layer>> @ traffic layer - constructor */
function TrafficConstruct(controlDiv, map_left, trafficLayer) {
	// Set CSS for the control border
	var trafficUI = document.createElement('div');
	trafficUI.id = 'trafficButtonUI';
	trafficUI.title = 'Click to toggle traffic layer';
	controlDiv.appendChild(trafficUI);

	// Set CSS for the control interior
	var trafficText = document.createElement('div');
	trafficText.id = 'trafficButtonText';
	trafficText.innerHTML = 'Traffic';
	trafficText.style.fontWeight = 'normal';
	trafficUI.appendChild(trafficText);

	// Set up the click event listener for show traffic table
	trafficUI.addEventListener('click', function(){
		var trafficState = trafficLayer.getMap();
		if ( trafficState != null){
			trafficLayer.setMap(null);
			trafficText.style.fontWeight = 'normal';
		} else {
			trafficLayer.setMap(map_left);
			trafficText.style.fontWeight = 'bold';
		}
	});
}

////////////////////////////////////////////////////////////////
/** <<GridNet>> @ customer overlay grid net - constructor */
function CoordMapType(tileSize) {
	this.tileSize = tileSize;
}
CoordMapType.prototype.getTile = function(coord, zoom, ownerDocument) {
	var div = ownerDocument.createElement('div');
	div.innerHTML = coord;
	div.style.color = 'white';
	div.style.width = this.tileSize.width + 'px';
	div.style.height = this.tileSize.height + 'px';
	div.style.fontSize = '10';
	div.style.borderStyle = 'dashed';
	div.style.borderWidth = '1px';
	div.style.borderColor = '#FFFFFF';
	return div;
};

////////////////////////////////////////////////////////////////
/** <<Basic>> @ basic google maps */
var map_left;
var map_right;
function initMap() {
	/** <<StyleMap>> @ complex styled maps - define*/
	var sisAtlas = new google.maps.StyledMapType(
	[
		{
			elementType: 'labels',
			stylers: [
				{ visibility: 'off' }
			]
		},{
			featureType: 'poi',
			elementType: 'geometry',
			stylers: [
				{ visibility: 'off' }
			]
		},{
			featureType: 'administrative',
			elementType: 'geometry',
			stylers: [
				{ visibility: 'off' }
			]
		},{
			featureType: 'transit',
			elementType: 'geometry',
			stylers: [
				{ visibility: 'off' }
			]
		},{
			featureType: 'water',
			elementType: 'geometry',
			stylers: [
				{ color: '#444444' }
			]
		},{
			featureType: 'landscape',
			elementType: 'geometry',
			stylers: [
				{ color: '#666666' }
			]
		},{
			featureType: 'road',
			elementType: 'geometry',
			stylers: [
				{ color: '#FFFFFF' }
			]
		},{
		}
	], 
	{name: 'MEGA-WEB Road Net'});
	
	/** <<Map>> @ map control - setting */
	// open traditional map control
	//google.maps.controlStyle = 'azteca';
	map_left = new google.maps.Map(document.getElementById('map_left'), {
		zoom: 9,
		center: init_pts,
		scrollwheel: false,
		scaleControl: true,
		zoomControl: true,
		zoomControlOptions: {
			style: google.maps.ZoomControlStyle.LARGE,
			position: google.maps.ControlPosition.RIGHT_CENTER
		},
		streetViewControl: false,
		streetViewControlOptions: {
			position: google.maps.ControlPosition.RIGHT_CENTER
		},
		rotateControl: true,
		rotateControlOptions :{
			position: google.maps.ControlPosition.RIGHT_CENTER
		},
		mapTypeControl: true,
		mapTypeControlOptions: {
			style: google.maps.MapTypeControlStyle.HORIZONTAL_BAR,	// HORIZONTAL_BAR | DROPDOWN_MENU
			position: google.maps.ControlPosition.TOP_RIGHT,
			mapTypeIds: [
				/** <<StyleMap>> @ complex styled maps - define*/
				'sisatlas', 
				google.maps.MapTypeId.ROADMAP,
				google.maps.MapTypeId.SATELLITE,
				google.maps.MapTypeId.HYBRID,
				google.maps.MapTypeId.TERRAIN
			]
		}
	});
	map_right = new google.maps.Map(document.getElementById('map_right'), {
		zoom: 9,
		center: init_pts,
		scrollwheel: false,
		scaleControl: true,
		zoomControl: true,
		zoomControlOptions: {
			style: google.maps.ZoomControlStyle.LARGE,
			position: google.maps.ControlPosition.LEFT_CENTER
		},
		streetViewControl: false,
		streetViewControlOptions: {
			position: google.maps.ControlPosition.LEFT_CENTER
		},
		rotateControl: true,
		rotateControlOptions :{
			position: google.maps.ControlPosition.LEFT_CENTER
		},
		mapTypeControl: true,
		mapTypeControlOptions: {
			style: google.maps.MapTypeControlStyle.HORIZONTAL_BAR,	// HORIZONTAL_BAR | DROPDOWN_MENU
			position: google.maps.ControlPosition.TOP_LEFT,
			mapTypeIds: [
				/** <<StyleMap>> @ complex styled maps - define*/
				'sisatlas', 
				google.maps.MapTypeId.ROADMAP,
				google.maps.MapTypeId.SATELLITE,
				google.maps.MapTypeId.HYBRID,
				google.maps.MapTypeId.TERRAIN
			]
		}
	});
	
	/** <<StyleMap>> @ complex styled maps - call*/
	map_left.mapTypes.set('sisatlas', sisAtlas);
	map_right.mapTypes.set('sisatlas', sisAtlas);
	
	// set default type
	map_left.setMapTypeId('sisatlas');
	map_right.setMapTypeId('sisatlas');
	//map_left.setMapTypeId(google.maps.MapTypeId.TERRAIN);
	
	/** <<GridNet>> @ customer overlay grid net - call*/
	map_left.overlayMapTypes.insertAt(0, new CoordMapType(new google.maps.Size(256, 256)));
	map_right.overlayMapTypes.insertAt(0, new CoordMapType(new google.maps.Size(256, 256)));
	
	// sycn two maps
	google.maps.event.addListener(map_left, 'bounds_changed', (function () {
		map_right.setZoom(map_left.getZoom());
	}));
	google.maps.event.addListener(map_right, 'bounds_changed', (function () {
		map_left.setZoom(map_right.getZoom());
	}));
	google.maps.event.addListener(map_left, 'dragend', (function () {
		
		var select_left = document.getElementById("select_left");
		var cityname_left = select_left.options[select_left.selectedIndex].value;
		var select_right = document.getElementById("select_right");
		var cityname_right = select_right.options[select_right.selectedIndex].value;
		if (cityname_left == cityname_right) {
			map_right.setCenter(map_left.getCenter());
		}
	}));
	google.maps.event.addListener(map_right, 'dragend', (function () {
		
		var select_left = document.getElementById("select_left");
		var cityname_left = select_left.options[select_left.selectedIndex].value;
		var select_right = document.getElementById("select_right");
		var cityname_right = select_right.options[select_right.selectedIndex].value;
		if (cityname_left == cityname_right) {
			map_left.setCenter(map_right.getCenter());
		}
	}));
	
	// dynamic selection
	buildDynaSelect();
	buildStaticSelect();
}

////////////////////////////////////////////////////////////////
/** <<Fly to>> @ map jump function */
function flyto(name, type) {
	var temp_lat = currentCapitalLocation[name + "_lat"];
	var temp_lon = currentCapitalLocation[name + "_lon"];

	var pos = {
		lat: temp_lat,
		lng: temp_lon
	};
	
	if (type == 'left'){
		map_left.setCenter(pos);
		map_left.setZoom(9);
		
		/** <<Google Chart>> @ control the google chart - call  */
		// control the chart table
		var chartTableName = currentKmlObjects[name + "_lulc_change"];
		drawChartLeft(name, chartTableName);
	} 
	if (type == 'right'){
		map_right.setCenter(pos);
		map_right.setZoom(9);
		
		/** <<Google Chart>> @ control the google chart - call  */
		// control the chart table
		var chartTableName = currentKmlObjects[name + "_lulc_change"];
		drawChartRight(name, chartTableName);
	}

	
}

function buildDynaSelect() {
	var select_left = document.getElementById("select_left");
	var select_right = document.getElementById("select_right");

	for (var city in citymap) {
		var val = citymap[city];
		select_left.options[select_left.options.length] = new Option(city, city);
		select_right.options[select_right.options.length] = new Option(city, city);
	}
}

function buildStaticSelect() {
	// left
	var select_type_left = document.getElementById("select_type_left");
	select_type_left.options[select_type_left.options.length] = new Option('Road Network', '_none');
	select_type_left.options[select_type_left.options.length] = new Option('LUC in Time 1 (2000±2)', '_lulc_t1');
	select_type_left.options[select_type_left.options.length] = new Option('LUC in Time 2 (2014±2)', '_lulc_t2');
	select_type_left.options[select_type_left.options.length] = new Option('LUCC', '_lulc_change');
	select_type_left.options[select_type_left.options.length] = new Option('LSPOP 2000', '_lspop_2000');
	select_type_left.options[select_type_left.options.length] = new Option('LSPOP 2013', '_lspop_2013');
	select_type_left.options[select_type_left.options.length] = new Option('ECI 2000', '_dmsp_2000');
	select_type_left.options[select_type_left.options.length] = new Option('ECI 2013', '_dmsp_2013');
	select_type_left.options[select_type_left.options.length] = new Option('Predicted LUC in 2030', '_modeling_2030');
	select_type_left.options[select_type_left.options.length] = new Option('Predicted LUC in 2050', '_modeling_2050');
	select_type_left.options[select_type_left.options.length] = new Option('LST in Time 1 (2000±2)', '_lst_t1');
	select_type_left.options[select_type_left.options.length] = new Option('LST in Time 2 (2014±2)', '_lst_t2');
	
	// right
	var select_type_right = document.getElementById("select_type_right");
	select_type_right.options[select_type_right.options.length] = new Option('Road Network', '_none');
	select_type_right.options[select_type_right.options.length] = new Option('LUC in Time 1 (2000±2)', '_lulc_t1');
	select_type_right.options[select_type_right.options.length] = new Option('LUC in Time 2 (2014±2)', '_lulc_t2');
	select_type_right.options[select_type_right.options.length] = new Option('LUCC', '_lulc_change');
	select_type_right.options[select_type_right.options.length] = new Option('LSPOP 2000', '_lspop_2000');
	select_type_right.options[select_type_right.options.length] = new Option('LSPOP 2013', '_lspop_2013');
	select_type_right.options[select_type_right.options.length] = new Option('ECI 2000', '_dmsp_2000');
	select_type_right.options[select_type_right.options.length] = new Option('ECI 2013', '_dmsp_2013');
	select_type_right.options[select_type_right.options.length] = new Option('Predicted LUC in 2030', '_modeling_2030');
	select_type_right.options[select_type_right.options.length] = new Option('Predicted LUC in 2050', '_modeling_2050');
	select_type_right.options[select_type_right.options.length] = new Option('LST in Time 1 (2000±2)', '_lst_t1');
	select_type_right.options[select_type_right.options.length] = new Option('LST in Time 2 (2014±2)', '_lst_t2');
}

////////////////////////////////////////////////////////////////
/** <<Legend>> @ control the legend */
function controlLegendLeft(legendID) {
	switch(legendID) {
		case 0:
			document.getElementById("legend_lulc_l").style.display="none";
			document.getElementById("legend_lcc_l").style.display="none";
			document.getElementById("legend_lspop_l").style.display="none";
			document.getElementById("legend_dmsp_l").style.display="none";
			document.getElementById("legend_modeling_l").style.display="none";
			document.getElementById("legend_lst_l").style.display="none";
			break
		case 1:
			document.getElementById("legend_lulc_l").style.display="";
			document.getElementById("legend_lcc_l").style.display="none";
			document.getElementById("legend_lspop_l").style.display="none";
			document.getElementById("legend_dmsp_l").style.display="none";
			document.getElementById("legend_modeling_l").style.display="none";
			document.getElementById("legend_lst_l").style.display="none";
			break;
		case 2:
			document.getElementById("legend_lulc_l").style.display="none";
			document.getElementById("legend_lcc_l").style.display="";
			document.getElementById("legend_lspop_l").style.display="none";
			document.getElementById("legend_dmsp_l").style.display="none";
			document.getElementById("legend_modeling_l").style.display="none";
			document.getElementById("legend_lst_l").style.display="none";
			break;
		case 3:
			document.getElementById("legend_lulc_l").style.display="none";
			document.getElementById("legend_lcc_l").style.display="none";
			document.getElementById("legend_lspop_l").style.display="";
			document.getElementById("legend_dmsp_l").style.display="none";
			document.getElementById("legend_modeling_l").style.display="none";
			document.getElementById("legend_lst_l").style.display="none";
			break;
		case 4:
			document.getElementById("legend_lulc_l").style.display="none";
			document.getElementById("legend_lcc_l").style.display="none";
			document.getElementById("legend_lspop_l").style.display="none";
			document.getElementById("legend_dmsp_l").style.display="";
			document.getElementById("legend_modeling_l").style.display="none";
			document.getElementById("legend_lst_l").style.display="none";
			break;
		case 5:
			document.getElementById("legend_lulc_l").style.display="none";
			document.getElementById("legend_lcc_l").style.display="none";
			document.getElementById("legend_lspop_l").style.display="none";
			document.getElementById("legend_dmsp_l").style.display="none";
			document.getElementById("legend_modeling_l").style.display="";
			document.getElementById("legend_lst_l").style.display="none";
			break;
		case 6:
			document.getElementById("legend_lulc_l").style.display="none";
			document.getElementById("legend_lcc_l").style.display="none";
			document.getElementById("legend_lspop_l").style.display="none";
			document.getElementById("legend_dmsp_l").style.display="none";
			document.getElementById("legend_modeling_l").style.display="none";
			document.getElementById("legend_lst_l").style.display="";
			break;
	}
}
function controlLegendRight(legendID) {
	switch(legendID) {
		case 0:
			document.getElementById("legend_lulc_r").style.display="none";
			document.getElementById("legend_lcc_r").style.display="none";
			document.getElementById("legend_lspop_r").style.display="none";
			document.getElementById("legend_dmsp_r").style.display="none";
			document.getElementById("legend_modeling_r").style.display="none";
			document.getElementById("legend_lst_r").style.display="none";
			break
		case 1:
			document.getElementById("legend_lulc_r").style.display="";
			document.getElementById("legend_lcc_r").style.display="none";
			document.getElementById("legend_lspop_r").style.display="none";
			document.getElementById("legend_dmsp_r").style.display="none";
			document.getElementById("legend_modeling_r").style.display="none";
			document.getElementById("legend_lst_r").style.display="none";
			break;
		case 2:
			document.getElementById("legend_lulc_r").style.display="none";
			document.getElementById("legend_lcc_r").style.display="";
			document.getElementById("legend_lspop_r").style.display="none";
			document.getElementById("legend_dmsp_r").style.display="none";
			document.getElementById("legend_modeling_r").style.display="none";
			document.getElementById("legend_lst_r").style.display="none";
			break;
		case 3:
			document.getElementById("legend_lulc_r").style.display="none";
			document.getElementById("legend_lcc_r").style.display="none";
			document.getElementById("legend_lspop_r").style.display="";
			document.getElementById("legend_dmsp_r").style.display="none";
			document.getElementById("legend_modeling_r").style.display="none";
			document.getElementById("legend_lst_r").style.display="none";
			break;
		case 4:
			document.getElementById("legend_lulc_r").style.display="none";
			document.getElementById("legend_lcc_r").style.display="none";
			document.getElementById("legend_lspop_r").style.display="none";
			document.getElementById("legend_dmsp_r").style.display="";
			document.getElementById("legend_modeling_r").style.display="none";
			document.getElementById("legend_lst_r").style.display="none";
			break;
		case 5:
			document.getElementById("legend_lulc_r").style.display="none";
			document.getElementById("legend_lcc_r").style.display="none";
			document.getElementById("legend_lspop_r").style.display="none";
			document.getElementById("legend_dmsp_r").style.display="none";
			document.getElementById("legend_modeling_r").style.display="";
			document.getElementById("legend_lst_r").style.display="none";
			break;
		case 6:
			document.getElementById("legend_lulc_r").style.display="none";
			document.getElementById("legend_lcc_r").style.display="none";
			document.getElementById("legend_lspop_r").style.display="none";
			document.getElementById("legend_dmsp_r").style.display="none";
			document.getElementById("legend_modeling_r").style.display="none";
			document.getElementById("legend_lst_r").style.display="";
			break;
	}
}




