
////////////////////////////////////////////////////////////////
/** <<Google Traffic layer>> @ traffic layer - constructor */
function TrafficConstruct(controlDiv, map, trafficLayer) {
	// Set CSS for the control border
	var trafficUI = document.createElement('div');
	trafficUI.id = 'trafficButtonUI';
	trafficUI.title = 'Click to toggle traffic layer';
	controlDiv.appendChild(trafficUI);

	// Set CSS for the control interior
	var trafficText = document.createElement('div');
	trafficText.id = 'trafficButtonText';
	trafficText.innerHTML = 'Traffic';
	trafficText.style.fontWeight = 'normal';
	trafficUI.appendChild(trafficText);

	// Set up the click event listener for show traffic table
	trafficUI.addEventListener('click', function(){
		var trafficState = trafficLayer.getMap();
		if ( trafficState != null){
			trafficLayer.setMap(null);
			trafficText.style.fontWeight = 'normal';
		} else {
			trafficLayer.setMap(map);
			trafficText.style.fontWeight = 'bold';
		}
	});
}

////////////////////////////////////////////////////////////////
/** <<GridNet>> @ customer overlay grid net - constructor */
function CoordMapType(tileSize) {
	this.tileSize = tileSize;
}
CoordMapType.prototype.getTile = function(coord, zoom, ownerDocument) {
	var div = ownerDocument.createElement('div');
	div.innerHTML = coord;
	div.style.color = 'white';
	div.style.width = this.tileSize.width + 'px';
	div.style.height = this.tileSize.height + 'px';
	div.style.fontSize = '10';
	div.style.borderStyle = 'dashed';
	div.style.borderWidth = '1px';
	div.style.borderColor = '#FFFFFF';
	return div;
};

////////////////////////////////////////////////////////////////
/** <<Basic>> @ basic google map */
var map;
function initMap() {
	/** <<StyleMap>> @ complex styled maps - define*/
	var sisAtlas = new google.maps.StyledMapType(
	[
		{
			elementType: 'labels',
			stylers: [
				{ visibility: 'off' }
			]
		},{
			featureType: 'poi',
			elementType: 'geometry',
			stylers: [
				{ visibility: 'off' }
			]
		},{
			featureType: 'administrative',
			elementType: 'geometry',
			stylers: [
				{ visibility: 'on' }
			]
		},{
			featureType: 'transit',
			elementType: 'geometry',
			stylers: [
				{ visibility: 'off' }
			]
		},{
			featureType: 'water',
			elementType: 'geometry',
			stylers: [
				{ color: '#444444' }
			]
		},{
			featureType: 'landscape',
			elementType: 'geometry',
			stylers: [
				{ color: '#666666' }
			]
		},{
			featureType: 'road',
			elementType: 'geometry',
			stylers: [
				{ color: '#999999' }
			]
		},{
		}
	], 
	{name: 'MEGA-WEB Road Net'});
	
	/** <<Map>> @ map control - setting */
	// open traditional map control
	//google.maps.controlStyle = 'azteca';
	map = new google.maps.Map(document.getElementById('map'), {
		zoom: 3,
		center: init_pts,
		scaleControl: true,
		scrollwheel: false,
		zoomControl: true,
		zoomControlOptions: {
			style: google.maps.ZoomControlStyle.LARGE,
			position: google.maps.ControlPosition.RIGHT_CENTER
		},
		streetViewControl: true,
		streetViewControlOptions: {
			position: google.maps.ControlPosition.RIGHT_CENTER
		},
		rotateControl: true,
		rotateControlOptions :{
			position: google.maps.ControlPosition.RIGHT_CENTER
		},
		mapTypeControl: true,
		mapTypeControlOptions: {
			style: google.maps.MapTypeControlStyle.HORIZONTAL_BAR,	// HORIZONTAL_BAR | DROPDOWN_MENU
			position: google.maps.ControlPosition.TOP_LEFT,
			mapTypeIds: [
				/** <<StyleMap>> @ complex styled maps - define*/
				'sisatlas', 
				google.maps.MapTypeId.ROADMAP,
				google.maps.MapTypeId.SATELLITE,
				google.maps.MapTypeId.HYBRID,
				google.maps.MapTypeId.TERRAIN
			]
		}
	});
	
	/** <<StyleMap>> @ complex styled maps - call*/
	map.mapTypes.set('sisatlas', sisAtlas);
	
	// set default map type
	map.setMapTypeId('sisatlas');
	//map.setMapTypeId(google.maps.MapTypeId.ROADMAP);
	
	/** <<GridNet>> @ customer overlay grid net - call*/
	//map.overlayMapTypes.insertAt(0, new CoordMapType(new google.maps.Size(256, 256)));
}


